'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _union = require('lodash/union');

var _union2 = _interopRequireDefault(_union);

var _findKey = require('lodash/findKey');

var _findKey2 = _interopRequireDefault(_findKey);

var _isPlainObject = require('lodash/isPlainObject');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

var _isUndefined = require('lodash/isUndefined');

var _isUndefined2 = _interopRequireDefault(_isUndefined);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var pathParamRe = /:([\d\w\-_]+)/g;
var httpMethodsRe = {
  get: /get|fetch|find|query/i,
  post: /post|create|send/,
  put: /put|update/,
  delete: /delete|remove|destroy/
};

var paginationParams = ['page', 'perPage'];

var Route = (function () {
  function Route(opts) {
    _classCallCheck(this, Route);

    this._opts = opts || {};
    this.path = this._opts.path;
    this.name = this._opts.name || 'action';

    this.method = this._suggestMethod();
    this.queryParams = this._queryParams();
  }

  _createClass(Route, [{
    key: 'pathFormat',
    value: function pathFormat(request) {
      var path = null;
      var queryString = null;
      var query = (0, _pick2.default)(request, this.queryParams);

      if ((0, _isPlainObject2.default)(request)) {
        path = this.path.replace(pathParamRe, function (match, group) {
          return request[group] || match;
        });
      }

      if ((0, _isPlainObject2.default)(query)) {
        query = (0, _omit2.default)(query, _isUndefined2.default);
        queryString = _qs2.default.stringify(query);
      }

      return queryString ? (path || '') + '?' + queryString : path;
    }
  }, {
    key: '_suggestMethod',
    value: function _suggestMethod() {
      var _this = this;

      var method = this._opts.method;

      return method || (0, _findKey2.default)(httpMethodsRe, function (methodRe) {
        return methodRe.test(_this.name);
      }) || 'get';
    }
  }, {
    key: '_queryParams',
    value: function _queryParams() {
      var queryParams = [];

      if (this._opts.pagination) {
        queryParams = (0, _union2.default)(queryParams, paginationParams);
      }

      if (this._opts.queryParams) {
        queryParams = (0, _union2.default)(queryParams, this._opts.queryParams);
      }

      return queryParams;
    }
  }]);

  return Route;
})();

exports.default = Route;